Index: drivers/filesystems/btrfs/free-space.c
===================================================================
--- drivers/filesystems/btrfs/free-space.c	(révision 75772)
+++ drivers/filesystems/btrfs/free-space.c	(copie de travail)
@@ -615,163 +684,326 @@
         do_rollback(Vcb, &rollback);
         return Status;
     }
-    
-    clear_rollback(Vcb, &rollback);
-    
+
+    clear_rollback(&rollback);
+
     c->cache->deleted = TRUE;
     mark_fcb_dirty(c->cache);
-    
-    free_fcb(c->cache);
+
+    c->old_cache = c->cache;
     c->cache = NULL;
+
+    le = c->space.Flink;
+    while (le != &c->space) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+        LIST_ENTRY* le2 = le->Flink;
+
+        RemoveEntryList(&s->list_entry);
+        RemoveEntryList(&s->list_entry_size);
+        ExFreePool(s);
+
+        le = le2;
+    }
+
     return STATUS_NOT_FOUND;
 }
 
-NTSTATUS load_free_space_cache(device_extension* Vcb, chunk* c, PIRP Irp) {
+static NTSTATUS load_stored_free_space_tree(device_extension* Vcb, chunk* c, PIRP Irp) {
+    KEY searchkey;
     traverse_ptr tp, next_tp;
+    NTSTATUS Status;
+    ULONG* bmparr = NULL;
+    ULONG bmplen = 0;
+    LIST_ENTRY* le;
+
+    TRACE("(%p, %llx)\n", Vcb, c->offset);
+
+    if (!Vcb->space_root)
+        return STATUS_NOT_FOUND;
+
+    searchkey.obj_id = c->offset;
+    searchkey.obj_type = TYPE_FREE_SPACE_INFO;
+    searchkey.offset = c->chunk_item->size;
+
+    Status = find_item(Vcb, Vcb->space_root, &tp, &searchkey, FALSE, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("find_item returned %08x\n", Status);
+        return Status;
+    }
+
+    if (keycmp(tp.item->key, searchkey)) {
+        TRACE("(%llx,%x,%llx) not found\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
+        return STATUS_NOT_FOUND;
+    }
+
+    if (tp.item->size < sizeof(FREE_SPACE_INFO)) {
+        WARN("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_INFO));
+        return STATUS_NOT_FOUND;
+    }
+
+    while (find_next_item(Vcb, &tp, &next_tp, FALSE, Irp)) {
+        tp = next_tp;
+
+        if (tp.item->key.obj_id >= c->offset + c->chunk_item->size)
+            break;
+
+        if (tp.item->key.obj_type == TYPE_FREE_SPACE_EXTENT) {
+            Status = add_space_entry(&c->space, &c->space_size, tp.item->key.obj_id, tp.item->key.offset);
+            if (!NT_SUCCESS(Status)) {
+                ERR("add_space_entry returned %08x\n", Status);
+                if (bmparr) ExFreePool(bmparr);
+                return Status;
+            }
+        } else if (tp.item->key.obj_type == TYPE_FREE_SPACE_BITMAP) {
+            ULONG explen, index, runlength;
+            RTL_BITMAP bmp;
+            UINT64 lastoff;
+
+            explen = (ULONG)(tp.item->key.offset / (Vcb->superblock.sector_size * 8));
+
+            if (tp.item->size < explen) {
+                WARN("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, explen);
+                return STATUS_NOT_FOUND;
+            } else if (tp.item->size == 0) {
+                WARN("(%llx,%x,%llx) has size of 0\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset);
+                return STATUS_NOT_FOUND;
+            }
+
+            if (bmplen < tp.item->size) {
+                if (bmparr)
+                    ExFreePool(bmparr);
+
+                bmplen = (ULONG)sector_align(tp.item->size, sizeof(ULONG));
+                bmparr = ExAllocatePoolWithTag(PagedPool, bmplen, ALLOC_TAG);
+                if (!bmparr) {
+                    ERR("out of memory\n");
+                    return STATUS_INSUFFICIENT_RESOURCES;
+                }
+            }
+
+            // We copy the bitmap because it supposedly has to be ULONG-aligned
+            RtlCopyMemory(bmparr, tp.item->data, tp.item->size);
+
+            RtlInitializeBitMap(&bmp, bmparr, (ULONG)(tp.item->key.offset / Vcb->superblock.sector_size));
+
+            lastoff = tp.item->key.obj_id;
+
+            runlength = RtlFindFirstRunClear(&bmp, &index);
+
+            while (runlength != 0) {
+                UINT64 runstart = tp.item->key.obj_id + (index * Vcb->superblock.sector_size);
+                UINT64 runend = runstart + (runlength * Vcb->superblock.sector_size);
+
+                if (runstart > lastoff) {
+                    Status = add_space_entry(&c->space, &c->space_size, lastoff, runstart - lastoff);
+                    if (!NT_SUCCESS(Status)) {
+                        ERR("add_space_entry returned %08x\n", Status);
+                        if (bmparr) ExFreePool(bmparr);
+                        return Status;
+                    }
+                }
+
+                lastoff = runend;
+
+                runlength = RtlFindNextForwardRunClear(&bmp, index + runlength, &index);
+            }
+
+            if (lastoff < tp.item->key.obj_id + tp.item->key.offset) {
+                Status = add_space_entry(&c->space, &c->space_size, lastoff, tp.item->key.obj_id + tp.item->key.offset - lastoff);
+                if (!NT_SUCCESS(Status)) {
+                    ERR("add_space_entry returned %08x\n", Status);
+                    if (bmparr) ExFreePool(bmparr);
+                    return Status;
+                }
+            }
+        }
+    }
+
+    if (bmparr)
+        ExFreePool(bmparr);
+
+    le = c->space.Flink;
+    while (le != &c->space) {
+        space* s = CONTAINING_RECORD(le, space, list_entry);
+        LIST_ENTRY* le2 = le->Flink;
+
+        if (le2 != &c->space) {
+            space* s2 = CONTAINING_RECORD(le2, space, list_entry);
+
+            if (s2->address == s->address + s->size) {
+                s->size += s2->size;
+
+                RemoveEntryList(&s2->list_entry);
+                RemoveEntryList(&s2->list_entry_size);
+                ExFreePool(s2);
+
+                RemoveEntryList(&s->list_entry_size);
+                order_space_entry(s, &c->space_size);
+
+                le2 = le;
+            }
+        }
+
+        le = le2;
+    }
+
+    return STATUS_SUCCESS;
+}
+
+static NTSTATUS load_free_space_cache(device_extension* Vcb, chunk* c, PIRP Irp) {
+    traverse_ptr tp, next_tp;
     KEY searchkey;
     UINT64 lastaddr;
     BOOL b;
     space* s;
     NTSTATUS Status;
-//     LIST_ENTRY* le;
-    
-    if (Vcb->superblock.generation - 1 == Vcb->superblock.cache_generation) {
-        Status = load_stored_free_space_cache(Vcb, c, Irp);
-        
+
+    if (Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE && Vcb->superblock.compat_ro_flags & BTRFS_COMPAT_RO_FLAGS_FREE_SPACE_CACHE_VALID) {
+        Status = load_stored_free_space_tree(Vcb, c, Irp);
+
         if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
+            ERR("load_stored_free_space_tree returned %08x\n", Status);
+            return Status;
+        }
+    } else if (Vcb->superblock.generation - 1 == Vcb->superblock.cache_generation) {
+        Status = load_stored_free_space_cache(Vcb, c, FALSE, Irp);
+
+        if (!NT_SUCCESS(Status) && Status != STATUS_NOT_FOUND) {
             ERR("load_stored_free_space_cache returned %08x\n", Status);
             return Status;
         }
     } else
         Status = STATUS_NOT_FOUND;
-     
+
     if (Status == STATUS_NOT_FOUND) {
         TRACE("generating free space cache for chunk %llx\n", c->offset);
-        
+
         searchkey.obj_id = c->offset;
         searchkey.obj_type = TYPE_EXTENT_ITEM;
         searchkey.offset = 0;
-        
+
         Status = find_item(Vcb, Vcb->extent_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         lastaddr = c->offset;
-        
+
         do {
             if (tp.item->key.obj_id >= c->offset + c->chunk_item->size)
                 break;
-            
+
             if (tp.item->key.obj_id >= c->offset && (tp.item->key.obj_type == TYPE_EXTENT_ITEM || tp.item->key.obj_type == TYPE_METADATA_ITEM)) {
                 if (tp.item->key.obj_id > lastaddr) {
                     s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
-                    
+
                     if (!s) {
                         ERR("out of memory\n");
                         return STATUS_INSUFFICIENT_RESOURCES;
                     }
-                    
+
                     s->address = lastaddr;
                     s->size = tp.item->key.obj_id - lastaddr;
                     InsertTailList(&c->space, &s->list_entry);
-                    
+
                     order_space_entry(s, &c->space_size);
-                    
+
                     TRACE("(%llx,%llx)\n", s->address, s->size);
                 }
-                
+
                 if (tp.item->key.obj_type == TYPE_METADATA_ITEM)
                     lastaddr = tp.item->key.obj_id + Vcb->superblock.node_size;
                 else
                     lastaddr = tp.item->key.obj_id + tp.item->key.offset;
             }
-            
+
             b = find_next_item(Vcb, &tp, &next_tp, FALSE, Irp);
             if (b)
                 tp = next_tp;
         } while (b);
-        
+
         if (lastaddr < c->offset + c->chunk_item->size) {
             s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
-            
+
             if (!s) {
                 ERR("out of memory\n");
                 return STATUS_INSUFFICIENT_RESOURCES;
             }
-            
+
             s->address = lastaddr;
             s->size = c->offset + c->chunk_item->size - lastaddr;
             InsertTailList(&c->space, &s->list_entry);
-            
+
             order_space_entry(s, &c->space_size);
-            
+
             TRACE("(%llx,%llx)\n", s->address, s->size);
         }
     }
-    
-//     le = c->space_size.Flink;
-//     while (le != &c->space_size) {
-//         space* s = CONTAINING_RECORD(le, space, list_entry_size);
-//         
-//         ERR("(%llx, %llx)\n", s->address, s->size);
-//         
-//         le = le->Flink;
-//     }
-//     ERR("---\n");
 
     return STATUS_SUCCESS;
 }
 
+NTSTATUS load_cache_chunk(device_extension* Vcb, chunk* c, PIRP Irp) {
+    NTSTATUS Status;
+
+    if (c->cache_loaded)
+        return STATUS_SUCCESS;
+
+    Status = load_free_space_cache(Vcb, c, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("load_free_space_cache returned %08x\n", Status);
+        return Status;
+    }
+
+    protect_superblocks(c);
+
+    c->cache_loaded = TRUE;
+
+    return STATUS_SUCCESS;
+}
+
 static NTSTATUS insert_cache_extent(fcb* fcb, UINT64 start, UINT64 length, LIST_ENTRY* rollback) {
+    NTSTATUS Status;
     LIST_ENTRY* le = fcb->Vcb->chunks.Flink;
     chunk* c;
     UINT64 flags;
-    
+
     flags = fcb->Vcb->data_flags;
-    
-    ExAcquireResourceSharedLite(&fcb->Vcb->chunk_lock, TRUE);
-    
+
     while (le != &fcb->Vcb->chunks) {
         c = CONTAINING_RECORD(le, chunk, list_entry);
-        
+
         if (!c->readonly && !c->reloc) {
             ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-            
+
             if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= length) {
-                if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length)) {
-                    ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
+                if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length, FALSE, 0))
                     return STATUS_SUCCESS;
-                }
             }
-            
+
             ExReleaseResourceLite(&c->lock);
         }
-        
+
         le = le->Flink;
     }
-    
-    ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
 
-    ExAcquireResourceExclusiveLite(&fcb->Vcb->chunk_lock, TRUE);
-    
-    if ((c = alloc_chunk(fcb->Vcb, flags))) {
-        ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-        
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        
-        if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= length) {
-            if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length))
-                return STATUS_SUCCESS;
-        }
-        
-        ExReleaseResourceLite(&c->lock);
-    } else   
-        ExReleaseResourceLite(&fcb->Vcb->chunk_lock);
-    
-    WARN("couldn't find any data chunks with %llx bytes free\n", length);
+    Status = alloc_chunk(fcb->Vcb, flags, &c, FALSE);
 
+    if (!NT_SUCCESS(Status)) {
+        ERR("alloc_chunk returned %08x\n", Status);
+        return Status;
+    }
+
+    ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+
+    if (c->chunk_item->type == flags && (c->chunk_item->size - c->used) >= length) {
+        if (insert_extent_chunk(fcb->Vcb, fcb, c, start, length, FALSE, NULL, NULL, rollback, BTRFS_COMPRESSION_NONE, length, FALSE, 0))
+            return STATUS_SUCCESS;
+    }
+
+    ExReleaseResourceLite(&c->lock);
+
     return STATUS_DISK_FULL;
 }
 
@@ -781,14 +1013,14 @@
     UINT64 num_entries, new_cache_size, i;
     UINT32 num_sectors;
     BOOL realloc_extents = FALSE;
-    
+
     // FIXME - also do bitmaps
     // FIXME - make sure this works when sector_size is not 4096
-    
+
     *changed = FALSE;
-    
+
     num_entries = 0;
-    
+
     // num_entries is the number of entries in c->space and c->deleting - it might
     // be slightly higher then what we end up writing, but doing it this way is much
     // quicker and simpler.
@@ -800,7 +1032,7 @@
             le = le->Flink;
         }
     }
-    
+
     if (!IsListEmpty(&c->deleting)) {
         le = c->deleting.Flink;
         while (le != &c->deleting) {
@@ -809,12 +1041,12 @@
             le = le->Flink;
         }
     }
-    
+
     new_cache_size = sizeof(UINT64) + (num_entries * sizeof(FREE_SPACE_ENTRY));
-    
-    num_sectors = sector_align(new_cache_size, Vcb->superblock.sector_size) / Vcb->superblock.sector_size;
-    num_sectors = sector_align(num_sectors, CACHE_INCREMENTS);
-    
+
+    num_sectors = (UINT32)sector_align(new_cache_size, Vcb->superblock.sector_size) / Vcb->superblock.sector_size;
+    num_sectors = (UINT32)sector_align(num_sectors, CACHE_INCREMENTS);
+
     // adjust for padding
     // FIXME - there must be a more efficient way of doing this
     new_cache_size = sizeof(UINT64) + (sizeof(UINT32) * num_sectors);
@@ -821,29 +1053,29 @@
     for (i = 0; i < num_entries; i++) {
         if ((new_cache_size / Vcb->superblock.sector_size) != ((new_cache_size + sizeof(FREE_SPACE_ENTRY)) / Vcb->superblock.sector_size))
             new_cache_size = sector_align(new_cache_size, Vcb->superblock.sector_size);
-        
+
         new_cache_size += sizeof(FREE_SPACE_ENTRY);
     }
-    
+
     new_cache_size = sector_align(new_cache_size, CACHE_INCREMENTS * Vcb->superblock.sector_size);
-    
+
     TRACE("chunk %llx: cache_size = %llx, new_cache_size = %llx\n", c->offset, c->cache ? c->cache->inode_item.st_size : 0, new_cache_size);
-    
+
     if (c->cache) {
         if (new_cache_size > c->cache->inode_item.st_size)
             realloc_extents = TRUE;
         else {
             le = c->cache->extents.Flink;
-            
+
             while (le != &c->cache->extents) {
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-                
-                if (!ext->ignore && (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->data->data[0];
-                    
+
+                if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
+
                     if (ed2->size != 0) {
                         chunk* c2 = get_chunk_from_address(Vcb, ed2->address);
-                        
+
                         if (c2 && (c2->readonly || c2->reloc)) {
                             realloc_extents = TRUE;
                             break;
@@ -850,150 +1082,168 @@
                         }
                     }
                 }
-                
+
                 le = le->Flink;
             }
         }
     }
-    
+
     if (!c->cache) {
         FREE_SPACE_ITEM* fsi;
         KEY searchkey;
         traverse_ptr tp;
-        
+
         // create new inode
-        
-        c->cache = create_fcb(PagedPool);
+
+        c->cache = create_fcb(Vcb, PagedPool);
         if (!c->cache) {
             ERR("out of memory\n");
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-            
+
         c->cache->Vcb = Vcb;
-        
+
         c->cache->inode_item.st_size = new_cache_size;
         c->cache->inode_item.st_blocks = new_cache_size;
         c->cache->inode_item.st_nlink = 1;
         c->cache->inode_item.st_mode = S_IRUSR | S_IWUSR | __S_IFREG;
         c->cache->inode_item.flags = BTRFS_INODE_NODATASUM | BTRFS_INODE_NODATACOW | BTRFS_INODE_NOCOMPRESS | BTRFS_INODE_PREALLOC;
-        
+
         c->cache->Header.IsFastIoPossible = fast_io_possible(c->cache);
         c->cache->Header.AllocationSize.QuadPart = 0;
         c->cache->Header.FileSize.QuadPart = 0;
         c->cache->Header.ValidDataLength.QuadPart = 0;
-        
+
         c->cache->subvol = Vcb->root_root;
-        
+
         c->cache->inode = InterlockedIncrement64(&Vcb->root_root->lastinode);
-        
+
         c->cache->type = BTRFS_TYPE_FILE;
         c->cache->created = TRUE;
-        
+
         // create new free space entry
-        
+
         fsi = ExAllocatePoolWithTag(PagedPool, sizeof(FREE_SPACE_ITEM), ALLOC_TAG);
         if (!fsi) {
             ERR("out of memory\n");
-            free_fcb(c->cache);
+            free_fcb(Vcb, c->cache);
             c->cache = NULL;
             return STATUS_INSUFFICIENT_RESOURCES;
         }
-        
+
         searchkey.obj_id = FREE_SPACE_CACHE_ID;
         searchkey.obj_type = 0;
         searchkey.offset = c->offset;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             ExFreePool(fsi);
-            free_fcb(c->cache);
+            free_fcb(Vcb, c->cache);
             c->cache = NULL;
             return Status;
         }
-        
-        if (!keycmp(searchkey, tp.item->key))
-            delete_tree_item(Vcb, &tp, rollback);
-        
+
+        if (!keycmp(searchkey, tp.item->key)) {
+            Status = delete_tree_item(Vcb, &tp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("delete_tree_item returned %08x\n", Status);
+                ExFreePool(fsi);
+                free_fcb(Vcb, c->cache);
+                c->cache = NULL;
+                return Status;
+            }
+        }
+
         fsi->key.obj_id = c->cache->inode;
         fsi->key.obj_type = TYPE_INODE_ITEM;
         fsi->key.offset = 0;
-        
-        if (!insert_tree_item(Vcb, Vcb->root_root, FREE_SPACE_CACHE_ID, 0, c->offset, fsi, sizeof(FREE_SPACE_ITEM), NULL, Irp, rollback)) {
-            ERR("insert_tree_item failed\n");
-            free_fcb(c->cache);
+
+        Status = insert_tree_item(Vcb, Vcb->root_root, FREE_SPACE_CACHE_ID, 0, c->offset, fsi, sizeof(FREE_SPACE_ITEM), NULL, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("insert_tree_item returned %08x\n", Status);
+            ExFreePool(fsi);
+            free_fcb(Vcb, c->cache);
             c->cache = NULL;
-            return STATUS_INTERNAL_ERROR;
+            return Status;
         }
-        
+
         // allocate space
-        
+
         Status = insert_cache_extent(c->cache, 0, new_cache_size, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("insert_cache_extent returned %08x\n", Status);
-            free_fcb(c->cache);
+            free_fcb(Vcb, c->cache);
             c->cache = NULL;
             return Status;
         }
-        
+
         c->cache->extents_changed = TRUE;
         InsertTailList(&Vcb->all_fcbs, &c->cache->list_entry_all);
-        
-        flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
-        
+
+        Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("flush_fcb returned %08x\n", Status);
+            free_fcb(Vcb, c->cache);
+            c->cache = NULL;
+            return Status;
+        }
+
         *changed = TRUE;
     } else if (realloc_extents) {
         KEY searchkey;
         traverse_ptr tp;
-        
+
         TRACE("reallocating extents\n");
-        
+
         // add free_space entry to tree cache
-        
+
         searchkey.obj_id = FREE_SPACE_CACHE_ID;
         searchkey.obj_type = 0;
         searchkey.offset = c->offset;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (keycmp(searchkey, tp.item->key)) {
             ERR("could not find (%llx,%x,%llx) in root_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (tp.item->size < sizeof(FREE_SPACE_ITEM)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_ITEM));
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         tp.tree->write = TRUE;
 
         // remove existing extents
-        
+
         if (c->cache->inode_item.st_size > 0) {
             le = c->cache->extents.Flink;
-            
+
             while (le != &c->cache->extents) {
                 extent* ext = CONTAINING_RECORD(le, extent, list_entry);
-                
-                if (!ext->ignore && (ext->data->type == EXTENT_TYPE_REGULAR || ext->data->type == EXTENT_TYPE_PREALLOC)) {
-                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->data->data[0];
-                    
+
+                if (!ext->ignore && (ext->extent_data.type == EXTENT_TYPE_REGULAR || ext->extent_data.type == EXTENT_TYPE_PREALLOC)) {
+                    EXTENT_DATA2* ed2 = (EXTENT_DATA2*)&ext->extent_data.data[0];
+
                     if (ed2->size != 0) {
                         chunk* c2 = get_chunk_from_address(Vcb, ed2->address);
-                        
-                        if (!c2->list_entry_changed.Flink)
-                            InsertTailList(&Vcb->chunks_changed, &c2->list_entry_changed);
+
+                        if (c2) {
+                            c2->changed = TRUE;
+                            c2->space_changed = TRUE;
+                        }
                     }
                 }
-                
+
                 le = le->Flink;
             }
-            
+
             Status = excise_extents(Vcb, c->cache, 0, c->cache->inode_item.st_size, Irp, rollback);
             if (!NT_SUCCESS(Status)) {
                 ERR("excise_extents returned %08x\n", Status);
@@ -1000,57 +1250,68 @@
                 return Status;
             }
         }
-        
+
         // add new extent
-        
+
         Status = insert_cache_extent(c->cache, 0, new_cache_size, rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("insert_cache_extent returned %08x\n", Status);
             return Status;
         }
-        
+
         // modify INODE_ITEM
-        
+
         c->cache->inode_item.st_size = new_cache_size;
         c->cache->inode_item.st_blocks = new_cache_size;
-        
-        flush_fcb(c->cache, TRUE, batchlist, Irp, rollback);
-    
+
+        Status = flush_fcb(c->cache, TRUE, batchlist, Irp);
+        if (!NT_SUCCESS(Status)) {
+            ERR("flush_fcb returned %08x\n", Status);
+            return Status;
+        }
+
         *changed = TRUE;
     } else {
         KEY searchkey;
         traverse_ptr tp;
-        
+
         // add INODE_ITEM and free_space entry to tree cache, for writing later
-        
+
         searchkey.obj_id = c->cache->inode;
         searchkey.obj_type = TYPE_INODE_ITEM;
         searchkey.offset = 0;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (keycmp(searchkey, tp.item->key)) {
             INODE_ITEM* ii;
-            
+
             ii = ExAllocatePoolWithTag(PagedPool, sizeof(INODE_ITEM), ALLOC_TAG);
+            if (!ii) {
+                ERR("out of memory\n");
+                return STATUS_INSUFFICIENT_RESOURCES;
+            }
+
             RtlCopyMemory(ii, &c->cache->inode_item, sizeof(INODE_ITEM));
-            
-            if (!insert_tree_item(Vcb, Vcb->root_root, c->cache->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp, rollback)) {
-                ERR("insert_tree_item failed\n");
-                return STATUS_INTERNAL_ERROR;
+
+            Status = insert_tree_item(Vcb, Vcb->root_root, c->cache->inode, TYPE_INODE_ITEM, 0, ii, sizeof(INODE_ITEM), NULL, Irp);
+            if (!NT_SUCCESS(Status)) {
+                ERR("insert_tree_item returned %08x\n", Status);
+                ExFreePool(ii);
+                return Status;
             }
-            
+
             *changed = TRUE;
-        } else {        
+        } else {
             if (tp.item->size < sizeof(INODE_ITEM)) {
                 ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(INODE_ITEM));
                 return STATUS_INTERNAL_ERROR;
             }
-            
+
             tp.tree->write = TRUE;
         }
 
@@ -1057,91 +1318,99 @@
         searchkey.obj_id = FREE_SPACE_CACHE_ID;
         searchkey.obj_type = 0;
         searchkey.offset = c->offset;
-        
+
         Status = find_item(Vcb, Vcb->root_root, &tp, &searchkey, FALSE, Irp);
         if (!NT_SUCCESS(Status)) {
             ERR("error - find_item returned %08x\n", Status);
             return Status;
         }
-        
+
         if (keycmp(searchkey, tp.item->key)) {
             ERR("could not find (%llx,%x,%llx) in root_root\n", searchkey.obj_id, searchkey.obj_type, searchkey.offset);
-            int3;
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         if (tp.item->size < sizeof(FREE_SPACE_ITEM)) {
             ERR("(%llx,%x,%llx) was %u bytes, expected %u\n", tp.item->key.obj_id, tp.item->key.obj_type, tp.item->key.offset, tp.item->size, sizeof(FREE_SPACE_ITEM));
             return STATUS_INTERNAL_ERROR;
         }
-        
+
         tp.tree->write = TRUE;
     }
-    
+
     // FIXME - reduce inode allocation if cache is shrinking. Make sure to avoid infinite write loops
-    
+
     return STATUS_SUCCESS;
 }
 
 NTSTATUS allocate_cache(device_extension* Vcb, BOOL* changed, PIRP Irp, LIST_ENTRY* rollback) {
-    LIST_ENTRY *le = Vcb->chunks_changed.Flink, batchlist;
+    LIST_ENTRY *le, batchlist;
     NTSTATUS Status;
 
     *changed = FALSE;
-    
+
     InitializeListHead(&batchlist);
-    
-    while (le != &Vcb->chunks_changed) {
-        BOOL b;
-        chunk* c = CONTAINING_RECORD(le, chunk, list_entry_changed);
 
-        ExAcquireResourceExclusiveLite(&c->lock, TRUE);
-        Status = allocate_cache_chunk(Vcb, c, &b, &batchlist, Irp, rollback);
-        ExReleaseResourceLite(&c->lock);
-        
-        if (b)
-            *changed = TRUE;
-        
-        if (!NT_SUCCESS(Status)) {
-            ERR("allocate_cache_chunk(%llx) returned %08x\n", c->offset, Status);
-            clear_batch_list(Vcb, &batchlist);
-            return Status;
+    ExAcquireResourceExclusiveLite(&Vcb->chunk_lock, TRUE);
+
+    le = Vcb->chunks.Flink;
+    while (le != &Vcb->chunks) {
+        chunk* c = CONTAINING_RECORD(le, chunk, list_entry);
+
+        if (c->space_changed) {
+            BOOL b;
+
+            ExAcquireResourceExclusiveLite(&c->lock, TRUE);
+            Status = allocate_cache_chunk(Vcb, c, &b, &batchlist, Irp, rollback);
+            ExReleaseResourceLite(&c->lock);
+
+            if (b)
+                *changed = TRUE;
+
+            if (!NT_SUCCESS(Status)) {
+                ERR("allocate_cache_chunk(%llx) returned %08x\n", c->offset, Status);
+                ExReleaseResourceLite(&Vcb->chunk_lock);
+                clear_batch_list(Vcb, &batchlist);
+                return Status;
+            }
         }
-        
+
         le = le->Flink;
     }
-    
-    commit_batch_list(Vcb, &batchlist, Irp, rollback);
-    
+
+    ExReleaseResourceLite(&Vcb->chunk_lock);
+
+    Status = commit_batch_list(Vcb, &batchlist, Irp);
+    if (!NT_SUCCESS(Status)) {
+        ERR("commit_batch_list returned %08x\n", Status);
+        return Status;
+    }
+
     return STATUS_SUCCESS;
 }
 
-static void add_rollback_space(device_extension* Vcb, LIST_ENTRY* rollback, BOOL add, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c) {
+static void add_rollback_space(LIST_ENTRY* rollback, BOOL add, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c) {
     rollback_space* rs;
-    
+
     rs = ExAllocatePoolWithTag(PagedPool, sizeof(rollback_space), ALLOC_TAG);
     if (!rs) {
         ERR("out of memory\n");
         return;
     }
-    
+
     rs->list = list;
     rs->list_size = list_size;
     rs->address = address;
     rs->length = length;
     rs->chunk = c;
-    
-    add_rollback(Vcb, rollback, add ? ROLLBACK_ADD_SPACE : ROLLBACK_SUBTRACT_SPACE, rs);
+
+    add_rollback(rollback, add ? ROLLBACK_ADD_SPACE : ROLLBACK_SUBTRACT_SPACE, rs);
 }
 
-void _space_list_add2(device_extension* Vcb, LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback, const char* func) {
+void space_list_add2(LIST_ENTRY* list, LIST_ENTRY* list_size, UINT64 address, UINT64 length, chunk* c, LIST_ENTRY* rollback) {
     LIST_ENTRY* le;
     space *s, *s2;
-    
-#ifdef DEBUG_SPACE_LISTS
-    _debug_message(func, "called space_list_add (%p, %llx, %llx, %p)\n", list, address, length, rollback);
-#endif
-    
+
     if (IsListEmpty(list)) {
         s = ExAllocatePoolWithTag(PagedPool, sizeof(space), ALLOC_TAG);
 
